/* wc - unix word count utility output is    lines words chars  */


/* grep  xxx  * | wc    or  cat xx | wc  if unix
                        or  type xx | wc  if dos

*/



#include <stdio.h>

#define MAX_BUF  255

main(int argc,char * argv[])
{

   long   lLines = 0;
   long   lWords = 0;
   long   lChars = 0;

   int    iLen;
   int    iCnt;
   
   char   cChar;
   char   cPrevChar;

   char   szBuffer[MAX_BUF + 1];

   char  * pc;



   while(!feof(stdin))
   {
      pc = fgets(szBuffer,MAX_BUF,stdin);

      if(pc == NULL)
         break;
      

      iLen = strlen(szBuffer);

      if(szBuffer[iLen -1] == '\n')
         szBuffer[iLen -1] = '\0';

      lChars += (long) strlen(szBuffer);

      
      cPrevChar = 0;

      for(iCnt = 0; iCnt < iLen; iCnt++)
      {
         cChar = szBuffer[iCnt];

         if(
            (cChar != ' ') && 
            (cPrevChar == ' ')
           )
            lWords++;

         cPrevChar = cChar;
      }

      
      lLines++;
   
   }


   printf("%ld %ld %ld\n", lLines, lWords, lChars);

   return(0);
}

