/***********************************************************************
**+
**  Module Name:  fio.h
**
**  Description:  fio defines
**
**  Written by:  John Tal
**
**
**  Modification history:
**
**  Date         Engineer     Mod #          Modification Description
**
**  12-FEB-1992  Tal          v 1.0-000      Initial release
**-
***********************************************************************/

#ifdef FIO_H
#else
#define FIO_H

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/timeb.h>


#include <memincs.h>


#define FIO_PERIOD   '.'
#define FIO_SEED_PATH_LEN 64
#define FIO_MAX_EXTENSION 999
#define FIO_EXTENSION_LEN 3

#define FIO_OK  0
#define FIO_NO_FILE -1
#define FIO_FILE_OLD -2
#define FIO_NO_CHAR -3

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif


#ifdef C_ANSI
SHORT APIENTRY FioGetFile(PCHAR);
SHORT APIENTRY FioRemoveFile(PCHAR);
SHORT APIENTRY FioIncSeedPathName(PCHAR);
SHORT APIENTRY FioFindChar(PCHAR,CHAR);
SHORT APIENTRY FioCheckFileClear(PCHAR);
SHORT APIENTRY FioReplaceExt(PCHAR,PCHAR);
#else
SHORT APIENTRY FioGetFile();
SHORT APIENTRY FioRemoveFile();
SHORT APIENTRY FioIncSeedPathName();
SHORT APIENTRY FioFindChar();
SHORT APIENTRY FioCheckFileClear();
SHORT APIENTRY FioReplaceExt();
#endif


#endif
